import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Grenadeer here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Grenadeer extends Enemy
{
    int health = 5;
    private Turret turret;
    private int weaponCooldown = 75;
    
    private void shoot()
    {
        if (weaponCooldown <= 0)
        {
            getWorld().addObject(new Grenade(turret), getX(), getY());
            weaponCooldown = 150;
        }
        else
        {
            weaponCooldown--;
        }
    }
    
    public Grenadeer(Turret turret)
    {
        this.turret = turret;
    }
    
    public void takeDamage(int x)
    {
        health -= x;
        
        if (health <= 0)
        {
            ((MyWorld)getWorld()).score.setValue(((MyWorld)getWorld()).score.getValue()+1);
            ((MyWorld)getWorld()).removeObject(this);
        }
    }
    
    /**
     * Act - do whatever the Grenadeer wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act()
    {
        
        if (
            Math.sqrt(
                Math.pow(getX()-turret.getX(), 2) +
                Math.pow(getY()-turret.getY(), 2)
            ) > 150
        )
        {
            move(0.75);
        }
        else
        {
            shoot();
        }
        
        turnTowards(turret.getX(), turret.getY());
    }
}
